/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: GED- (bitmap mode)           */
/***************************************/

; Assemble RastaConverter Slide Show
; PIC_QTY label passed on MADS command line

; DEFLATE is a forward loader
; compressed data needs to be loaded higher than decompressed data if overlapping.
; largest compressed picture data seen in testing is around 16K.
; Assuming at least a 48K Atari the compressed data will be loaded at a variable
; address to the top of memory as there were overlap problems with a fixed address
; and highly compressed data in very sparse pictures.

ramsize = 1024*48		; 48K RAM required

	icl "viewer.asm"

	.rept PIC_QTY, [#+1]
	ini info
	icl '_info:1.asm'
	loadpic '_pic:1.deflate', pic
	ini viewer	
	.endr

	run $e474		; warm start to loop slides


loadpic	.macro
	opt h-
	dta a (ramsize - .filesize :1, ramsize - 1)
	ins :1
	dta a (inflate_zp, inflate_zp+3, ramsize - .filesize :1, :2)
	opt h +
	ini inflate
	.endm 