/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: GED- (bitmap mode)           */
/***************************************/

; RastaSlide viewer program adapted from "no_name" in RastaConverter by Ilmenit
; static code and data only

	icl "no_name.h"		; NB shadow colours are mapped to hardware ones

	org $00

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1
;byt2	.ds 1
byt2	= $ea			; same as NOP for small compression gain

	org $80

dlst	.ds 2
sadr	.ds 2
timer	.ds 2

inflate_zp


* ---	BASIC switch OFF and make DLIST
;	org $2000\ mva #$ff portb\ rts\ ini $2000
	org $2000

	mva #$ff portb

; RasterConverter DLIST is over 0.7K and doesn't compress at all,
; so dynamically generating it is worthwhile

	lda #0
	tay
	tax
	sta dlst
	lda #>ant		; DLIST address
	sta dlst+1
	lda #<scr		; screen address
	sta sadr
	lda #>scr
	sta sadr+1

md1	lda #$4e
	jsr write_dlist
	lda sadr
	jsr write_dlist
	cpx #203		; so the awkward 2nd LMS 4K boundary isn't mid-line
	bne md2
	adc #16-1		; C pre-set, and assumed not set again by add
md2	clc
	adc #40
	sta sadr
	lda sadr+1
	jsr write_dlist
	adc #0
	sta sadr+1
	inx
	cpx #240
	bne md1

	lda #$41
	jsr write_dlist
	lda #<ant
	jsr write_dlist
	lda #>ant
;	jsr write_dlist
;	rts

write_dlist
	sta (dlst),y
	iny
	bne wd1
	inc dlst+1
wd1	rts

	ini $2000		; make display list during initial load

;---

* ---	MAIN PROGRAM
;	org $2010
	org $2000

viewer
main

* ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		; missiles and players data address
	mva #$03 pmcntl		; enable players and missiles
	eif

	lda pic_time		; exit timer in seconds 0-127
	sta timer+1
	lda #1
	sta timer		; reset jiffies

	lda:cmp:req $14		; wait 1 frame
	
	sei			; stop interrupts	
	mva #$00 nmien		; stop all interrupts
;	mva #$fe portb		; switch off ROM to get 16k more ram
	
;	jmp line239
	jmp raster_program_end	; initialize and show picture

LOOP	lda vcount		; synchronization for the first screen line
	cmp #$02
	bne LOOP

	mva #%00111110 dmactl	; set new screen width
	mva <ant dlptr
	mva >ant dlptr+1
	
	jsr raster_program

;
;  picture specific data that was here is split out from viewer code now
;

raster_program_end

;	lda >fnt+$400*$00	; fonts not used. also just so happens to take
;	sta chbase		; same cycles as added rts in raster program,
c0	lda #$00		; although the timing is not that critical
	sta colbak
c1	lda #$00
	sta color0
c2	lda #$00
	sta color1
c3	lda #$00
	sta color2
c4	lda #$00
	sta color3
s0	lda #$03
	sta sizep0
	sta sizep1
	sta sizep2
	sta sizep3
	mva #$ff sizem
	sta grafm
	mva #$20 hposm0
	mva #$28 hposm1
	mva #$d0 hposm2
	mva #$d8 hposm3
	mva #$02 pmcntl
	lda #$14
	sta gtictl


//--------------------
//	EXIT
//--------------------
	
	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl		; ANY KEY
	and #$04
	beq stop

	.if PIC_QTY = 1
	nop			; no timer if only one picture
	nop			; nops to keep addresses same
	.else
	dec timer		; TIMER (zero page)
	.endif
	bne skp
	lda PAL			; 00001111/00000001 (NTSC/PAL)
	eor #51			; 00110011/00110011            
	sta timer		; 00111100/00110010 (60/50)
	dec timer+1
	bpl skp
	
stop	mva #$00 pmcntl		; PMG disabled
	tax
	sta:rne hposp0,x+

;	mva #$ff portb		; ROM switch on
	mva #$40 nmien		; only NMI interrupts, DLI disabled
	cli			; IRQ enabled

	rts			; return to ... DOS
skp

//--------------------

	jmp LOOP

;---

;wait54cycle
;	:2 inc byt2
;wait44cycle
;	inc byt3
;	nop
;wait36cycle
;	inc byt3
;	jsr _rts
;wait18cycle
;	inc byt3
;_rts	rts

;byt3	brk

/////////////////
// INFO SCREEN //
/////////////////

info
	.local

COLOR2 = 710			; this is only local
SDLSTL = 560
SDLSTH = 561

	lda #0			; set black text background
	sta COLOR2		; proper shadow address, unlike RastaConverter
	tax
is1	sta pic_info,x		; clear pic info area
	inx
	bne is1	
	lda #<info_dlist
	sta SDLSTL
	lda #>info_dlist
	sta SDLSTH
	lda $14
is2	cmp $14
	beq is2			; wait until OS VBI shadow processing done
	rts
	
	.endl

info_dlist
	.byte 112, 112, 112, 112, 112
	.byte 2+64
	.byte <pic_name, >pic_name
	.byte 65, <info_dlist, >info_dlist


//////////////////
// DECOMPRESSOR //
//////////////////

inflate
	icl "inflate.asm"

inflate_data = 256*>(inflate + $200) + 256

;---


//----------------------------
//	VIEWER CODE END
//----------------------------

;---

//////////////////////
// PIC DISPLAY LIST //
//////////////////////

;	.ALIGN $0400
;ant	ANTIC_PROGRAM scr,ant	; DLIST now dynamically made by ini

;fnt				; fonts never used

	.ALIGN $0800		; actual PM base and DLIST
ant	.ds $300		; to nearest page to avoid ANTIC 4K boundary

//////////////////
// PICTURE DATA //
//////////////////

; picture data format structure only. see pic.asm for actual data

///////////////////
// PICTURE INFO ///
///////////////////

pic_info			; make use of unused missile area
pic_time
	.ds 1
pic_name	
	.ds $ff


;--- start of compressed picture data
pic

/////////////////////////
// PLAYER/MISSILE DATA //
/////////////////////////

pmg	.ds $400
	
////////////////////////
// SCREEN BITMAP DATA //
////////////////////////

	.ALIGN $1000
	.ds 16
scr

; pad picture size to maximum possible so raster program address is constant
; 240*40=9600 + 16 for 2nd 4K boundary padding

	.ds 240*40+16

////////////////////
// RASTER PROGRAM //
////////////////////

raster_program


;---

USESPRITES = 1			; viewer is general so always has P/M Graphics
